Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -2015,452 +2921,141 @@
 ImGuiID ImGuiWindow::GetIDFromRectangle(const ImRect& r_abs)
 {
-   ImGuiID seed = IDStack.back();
-   const int r_rel[4] = { (int)(r_abs.Min.x - Pos.x), (int)(r_abs.Min.y - Pos.y), (int)(r_abs.Max.x - Pos.x), (int)(r_abs.Max.y - Pos.y) };
-   ImGuiID id = ImHash(&r_rel, sizeof(r_rel), seed);
-   ImGui::KeepAliveID(id);
-   return id;
-}
-
-//-----------------------------------------------------------------------------
-// Internal API exposed in imgui_internal.h
-//-----------------------------------------------------------------------------
+    ImGuiID seed = IDStack.back();
+    const int r_rel[4] = { (int)(r_abs.Min.x - Pos.x), (int)(r_abs.Min.y - Pos.y), (int)(r_abs.Max.x - Pos.x), (int)(r_abs.Max.y - Pos.y) };
+    ImGuiID id = ImHashData(&r_rel, sizeof(r_rel), seed);
+    ImGui::KeepAliveID(id);
+    return id;
+}
 
 static void SetCurrentWindow(ImGuiWindow* window)
 {
-   ImGuiContext& g = *GImGui;
-   g.CurrentWindow = window;
-   if (window)
-      g.FontSize = g.DrawListSharedData.FontSize = window->CalcFontSize();
-}
-
-static void SetNavID(ImGuiID id, int nav_layer)
-{
-   ImGuiContext& g = *GImGui;
-   IM_ASSERT(g.NavWindow);
-   IM_ASSERT(nav_layer == 0 || nav_layer == 1);
-   g.NavId = id;
-   g.NavWindow->NavLastIds[nav_layer] = id;
-}
-
-static void SetNavIDWithRectRel(ImGuiID id, int nav_layer, const ImRect& rect_rel)
-{
-   ImGuiContext& g = *GImGui;
-   SetNavID(id, nav_layer);
-   g.NavWindow->NavRectRel[nav_layer] = rect_rel;
-   g.NavMousePosDirty = true;
-   g.NavDisableHighlight = false;
-   g.NavDisableMouseHover = true;
+    ImGuiContext& g = *GImGui;
+    g.CurrentWindow = window;
+    if (window)
+        g.FontSize = g.DrawListSharedData.FontSize = window->CalcFontSize();
+}
+
+// Free up/compact internal window buffers, we can use this when a window becomes unused.
+// This is currently unused by the library, but you may call this yourself for easy GC.
+// Not freed:
+// - ImGuiWindow, ImGuiWindowSettings, Name
+// - StateStorage, ColumnsStorage (may hold useful data)
+// This should have no noticeable visual effect. When the window reappear however, expect new allocation/buffer growth/copy cost.
+void ImGui::GcCompactTransientWindowBuffers(ImGuiWindow* window)
+{
+    window->MemoryCompacted = true;
+    window->MemoryDrawListIdxCapacity = window->DrawList->IdxBuffer.Capacity;
+    window->MemoryDrawListVtxCapacity = window->DrawList->VtxBuffer.Capacity;
+    window->IDStack.clear();
+    window->DrawList->_ClearFreeMemory();
+    window->DC.ChildWindows.clear();
+    window->DC.ItemFlagsStack.clear();
+    window->DC.ItemWidthStack.clear();
+    window->DC.TextWrapPosStack.clear();
+    window->DC.GroupStack.clear();
+}
+
+void ImGui::GcAwakeTransientWindowBuffers(ImGuiWindow* window)
+{
+    // We stored capacity of the ImDrawList buffer to reduce growth-caused allocation/copy when awakening.
+    // The other buffers tends to amortize much faster.
+    window->MemoryCompacted = false;
+    window->DrawList->IdxBuffer.reserve(window->MemoryDrawListIdxCapacity);
+    window->DrawList->VtxBuffer.reserve(window->MemoryDrawListVtxCapacity);
+    window->MemoryDrawListIdxCapacity = window->MemoryDrawListVtxCapacity = 0;
 }
 
 void ImGui::SetActiveID(ImGuiID id, ImGuiWindow* window)
 {
-   ImGuiContext& g = *GImGui;
-   g.ActiveIdIsJustActivated = (g.ActiveId != id);
-   if (g.ActiveIdIsJustActivated)
-      g.ActiveIdTimer = 0.0f;
-   g.ActiveId = id;
-   g.ActiveIdAllowNavDirFlags = 0;
-   g.ActiveIdAllowOverlap = false;
-   g.ActiveIdWindow = window;
-   if (id)
-   {
-      g.ActiveIdIsAlive = true;
-      g.ActiveIdSource = (g.NavActivateId == id || g.NavInputId == id || g.NavJustTabbedId == id || g.NavJustMovedToId == id) ? ImGuiInputSource_Nav : ImGuiInputSource_Mouse;
-   }
-}
-
-ImGuiID ImGui::GetActiveID()
-{
-   ImGuiContext& g = *GImGui;
-   return g.ActiveId;
-}
-
-void ImGui::SetFocusID(ImGuiID id, ImGuiWindow* window)
-{
-   ImGuiContext& g = *GImGui;
-   IM_ASSERT(id != 0);
-
-   // Assume that SetFocusID() is called in the context where its NavLayer is the current layer, which is the case everywhere we call it.
-   const int nav_layer = window->DC.NavLayerCurrent;
-   if (g.NavWindow != window)
-      g.NavInitRequest = false;
-   g.NavId = id;
-   g.NavWindow = window;
-   g.NavLayer = nav_layer;
-   window->NavLastIds[nav_layer] = id;
-   if (window->DC.LastItemId == id)
-      window->NavRectRel[nav_layer] = ImRect(window->DC.LastItemRect.Min - window->Pos, window->DC.LastItemRect.Max - window->Pos);
-
-   if (g.ActiveIdSource == ImGuiInputSource_Nav)
-      g.NavDisableMouseHover = true;
-   else
-      g.NavDisableHighlight = true;
+    ImGuiContext& g = *GImGui;
+    g.ActiveIdIsJustActivated = (g.ActiveId != id);
+    if (g.ActiveIdIsJustActivated)
+    {
+        g.ActiveIdTimer = 0.0f;
+        g.ActiveIdHasBeenPressedBefore = false;
+        g.ActiveIdHasBeenEditedBefore = false;
+        if (id != 0)
+        {
+            g.LastActiveId = id;
+            g.LastActiveIdTimer = 0.0f;
+        }
+    }
+    g.ActiveId = id;
+    g.ActiveIdAllowOverlap = false;
+    g.ActiveIdNoClearOnFocusLoss = false;
+    g.ActiveIdWindow = window;
+    g.ActiveIdHasBeenEditedThisFrame = false;
+    if (id)
+    {
+        g.ActiveIdIsAlive = id;
+        g.ActiveIdSource = (g.NavActivateId == id || g.NavInputId == id || g.NavJustTabbedId == id || g.NavJustMovedToId == id) ? ImGuiInputSource_Nav : ImGuiInputSource_Mouse;
+    }
+
+    // Clear declaration of inputs claimed by the widget
+    // (Please note that this is WIP and not all keys/inputs are thoroughly declared by all widgets yet)
+    g.ActiveIdUsingNavDirMask = 0x00;
+    g.ActiveIdUsingNavInputMask = 0x00;
+    g.ActiveIdUsingKeyInputMask = 0x00;
 }
 
 void ImGui::ClearActiveID()
 {
-   SetActiveID(0, NULL);
+    SetActiveID(0, NULL); // g.ActiveId = 0;
 }
 
 void ImGui::SetHoveredID(ImGuiID id)
 {
-   ImGuiContext& g = *GImGui;
-   g.HoveredId = id;
-   g.HoveredIdAllowOverlap = false;
-   g.HoveredIdTimer = (id != 0 && g.HoveredIdPreviousFrame == id) ? (g.HoveredIdTimer + g.IO.DeltaTime) : 0.0f;
+    ImGuiContext& g = *GImGui;
+    g.HoveredId = id;
+    g.HoveredIdAllowOverlap = false;
+    if (id != 0 && g.HoveredIdPreviousFrame != id)
+        g.HoveredIdTimer = g.HoveredIdNotActiveTimer = 0.0f;
 }
 
 ImGuiID ImGui::GetHoveredID()
 {
-   ImGuiContext& g = *GImGui;
-   return g.HoveredId ? g.HoveredId : g.HoveredIdPreviousFrame;
+    ImGuiContext& g = *GImGui;
+    return g.HoveredId ? g.HoveredId : g.HoveredIdPreviousFrame;
 }
 
 void ImGui::KeepAliveID(ImGuiID id)
 {
-   ImGuiContext& g = *GImGui;
-   if (g.ActiveId == id)
-      g.ActiveIdIsAlive = true;
+    ImGuiContext& g = *GImGui;
+    if (g.ActiveId == id)
+        g.ActiveIdIsAlive = id;
+    if (g.ActiveIdPreviousFrame == id)
+        g.ActiveIdPreviousFrameIsAlive = true;
+}
+
+void ImGui::MarkItemEdited(ImGuiID id)
+{
+    // This marking is solely to be able to provide info for IsItemDeactivatedAfterEdit().
+    // ActiveId might have been released by the time we call this (as in the typical press/release button behavior) but still need need to fill the data.
+    ImGuiContext& g = *GImGui;
+    IM_ASSERT(g.ActiveId == id || g.ActiveId == 0 || g.DragDropActive);
+    IM_UNUSED(id); // Avoid unused variable warnings when asserts are compiled out.
+    //IM_ASSERT(g.CurrentWindow->DC.LastItemId == id);
+    g.ActiveIdHasBeenEditedThisFrame = true;
+    g.ActiveIdHasBeenEditedBefore = true;
+    g.CurrentWindow->DC.LastItemStatusFlags |= ImGuiItemStatusFlags_Edited;
 }
 
 static inline bool IsWindowContentHoverable(ImGuiWindow* window, ImGuiHoveredFlags flags)
 {
-   // An active popup disable hovering on other windows (apart from its own children)
-   // FIXME-OPT: This could be cached/stored within the window.
-   ImGuiContext& g = *GImGui;
-   if (g.NavWindow)
-      if (ImGuiWindow* focused_root_window = g.NavWindow->RootWindow)
-         if (focused_root_window->WasActive && focused_root_window != window->RootWindow)
-         {
-            // For the purpose of those flags we differentiate "standard popup" from "modal popup"
-            // NB: The order of those two tests is important because Modal windows are also Popups.
-            if (focused_root_window->Flags & ImGuiWindowFlags_Modal)
-               return false;
-            if ((focused_root_window->Flags & ImGuiWindowFlags_Popup) && !(flags & ImGuiHoveredFlags_AllowWhenBlockedByPopup))
-               return false;
-         }
-
-   return true;
-}
-
-// Advance cursor given item size for layout.
-void ImGui::ItemSize(const ImVec2& size, float text_offset_y)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   if (window->SkipItems)
-      return;
-
-   // Always align ourselves on pixel boundaries
-   const float line_height = ImMax(window->DC.CurrentLineHeight, size.y);
-   const float text_base_offset = ImMax(window->DC.CurrentLineTextBaseOffset, text_offset_y);
-   //if (g.IO.KeyAlt) window->DrawList->AddRect(window->DC.CursorPos, window->DC.CursorPos + ImVec2(size.x, line_height), IM_COL32(255,0,0,200)); // [DEBUG]
-   window->DC.CursorPosPrevLine = ImVec2(window->DC.CursorPos.x + size.x, window->DC.CursorPos.y);
-   window->DC.CursorPos = ImVec2((float)(int)(window->Pos.x + window->DC.IndentX + window->DC.ColumnsOffsetX), (float)(int)(window->DC.CursorPos.y + line_height + g.Style.ItemSpacing.y));
-   window->DC.CursorMaxPos.x = ImMax(window->DC.CursorMaxPos.x, window->DC.CursorPosPrevLine.x);
-   window->DC.CursorMaxPos.y = ImMax(window->DC.CursorMaxPos.y, window->DC.CursorPos.y - g.Style.ItemSpacing.y);
-   //if (g.IO.KeyAlt) window->DrawList->AddCircle(window->DC.CursorMaxPos, 3.0f, IM_COL32(255,0,0,255), 4); // [DEBUG]
-
-   window->DC.PrevLineHeight = line_height;
-   window->DC.PrevLineTextBaseOffset = text_base_offset;
-   window->DC.CurrentLineHeight = window->DC.CurrentLineTextBaseOffset = 0.0f;
-
-   // Horizontal layout mode
-   if (window->DC.LayoutType == ImGuiLayoutType_Horizontal)
-      SameLine();
-}
-
-void ImGui::ItemSize(const ImRect& bb, float text_offset_y)
-{
-   ItemSize(bb.GetSize(), text_offset_y);
-}
-
-static ImGuiDir NavScoreItemGetQuadrant(float dx, float dy)
-{
-   if (fabsf(dx) > fabsf(dy))
-      return (dx > 0.0f) ? ImGuiDir_Right : ImGuiDir_Left;
-   return (dy > 0.0f) ? ImGuiDir_Down : ImGuiDir_Up;
-}
-
-static float NavScoreItemDistInterval(float a0, float a1, float b0, float b1)
-{
-   if (a1 < b0)
-      return a1 - b0;
-   if (b1 < a0)
-      return a0 - b1;
-   return 0.0f;
-}
-
-// Scoring function for directional navigation. Based on https://gist.github.com/rygorous/6981057
-static bool NavScoreItem(ImGuiNavMoveResult* result, ImRect cand)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   if (g.NavLayer != window->DC.NavLayerCurrent)
-      return false;
-
-   const ImRect& curr = g.NavScoringRectScreen; // Current modified source rect (NB: we've applied Max.x = Min.x in NavUpdate() to inhibit the effect of having varied item width)
-   g.NavScoringCount++;
-
-   // We perform scoring on items bounding box clipped by their parent window on the other axis (clipping on our movement axis would give us equal scores for all clipped items)
-   if (g.NavMoveDir == ImGuiDir_Left || g.NavMoveDir == ImGuiDir_Right)
-   {
-      cand.Min.y = ImClamp(cand.Min.y, window->ClipRect.Min.y, window->ClipRect.Max.y);
-      cand.Max.y = ImClamp(cand.Max.y, window->ClipRect.Min.y, window->ClipRect.Max.y);
-   }
-   else
-   {
-      cand.Min.x = ImClamp(cand.Min.x, window->ClipRect.Min.x, window->ClipRect.Max.x);
-      cand.Max.x = ImClamp(cand.Max.x, window->ClipRect.Min.x, window->ClipRect.Max.x);
-   }
-
-   // Compute distance between boxes
-   // FIXME-NAV: Introducing biases for vertical navigation, needs to be removed.
-   float dbx = NavScoreItemDistInterval(cand.Min.x, cand.Max.x, curr.Min.x, curr.Max.x);
-   float dby = NavScoreItemDistInterval(ImLerp(cand.Min.y, cand.Max.y, 0.2f), ImLerp(cand.Min.y, cand.Max.y, 0.8f), ImLerp(curr.Min.y, curr.Max.y, 0.2f), ImLerp(curr.Min.y, curr.Max.y, 0.8f)); // Scale down on Y to keep using box-distance for vertically touching items
-   if (dby != 0.0f && dbx != 0.0f)
-      dbx = (dbx / 1000.0f) + ((dbx > 0.0f) ? +1.0f : -1.0f);
-   float dist_box = fabsf(dbx) + fabsf(dby);
-
-   // Compute distance between centers (this is off by a factor of 2, but we only compare center distances with each other so it doesn't matter)
-   float dcx = (cand.Min.x + cand.Max.x) - (curr.Min.x + curr.Max.x);
-   float dcy = (cand.Min.y + cand.Max.y) - (curr.Min.y + curr.Max.y);
-   float dist_center = fabsf(dcx) + fabsf(dcy); // L1 metric (need this for our connectedness guarantee)
-
-                                                // Determine which quadrant of 'curr' our candidate item 'cand' lies in based on distance
-   ImGuiDir quadrant;
-   float dax = 0.0f, day = 0.0f, dist_axial = 0.0f;
-   if (dbx != 0.0f || dby != 0.0f)
-   {
-      // For non-overlapping boxes, use distance between boxes
-      dax = dbx;
-      day = dby;
-      dist_axial = dist_box;
-      quadrant = NavScoreItemGetQuadrant(dbx, dby);
-   }
-   else if (dcx != 0.0f || dcy != 0.0f)
-   {
-      // For overlapping boxes with different centers, use distance between centers
-      dax = dcx;
-      day = dcy;
-      dist_axial = dist_center;
-      quadrant = NavScoreItemGetQuadrant(dcx, dcy);
-   }
-   else
-   {
-      // Degenerate case: two overlapping buttons with same center, break ties arbitrarily (note that LastItemId here is really the _previous_ item order, but it doesn't matter)
-      quadrant = (window->DC.LastItemId < g.NavId) ? ImGuiDir_Left : ImGuiDir_Right;
-   }
-
-#if IMGUI_DEBUG_NAV_SCORING
-   char buf[128];
-   if (ImGui::IsMouseHoveringRect(cand.Min, cand.Max))
-   {
-      ImFormatString(buf, IM_ARRAYSIZE(buf), "dbox (%.2f,%.2f->%.4f)\ndcen (%.2f,%.2f->%.4f)\nd (%.2f,%.2f->%.4f)\nnav %c, quadrant %c", dbx, dby, dist_box, dcx, dcy, dist_center, dax, day, dist_axial, "WENS"[g.NavMoveDir], "WENS"[quadrant]);
-      ImDrawList* draw_list = ImGui::GetOverlayDrawList();
-      draw_list->AddRect(curr.Min, curr.Max, IM_COL32(255, 200, 0, 100));
-      draw_list->AddRect(cand.Min, cand.Max, IM_COL32(255, 255, 0, 200));
-      draw_list->AddRectFilled(cand.Max - ImVec2(4, 4), cand.Max + ImGui::CalcTextSize(buf) + ImVec2(4, 4), IM_COL32(40, 0, 0, 150));
-      draw_list->AddText(g.IO.FontDefault, 13.0f, cand.Max, ~0U, buf);
-   }
-   else if (g.IO.KeyCtrl) // Hold to preview score in matching quadrant. Press C to rotate.
-   {
-      if (IsKeyPressedMap(ImGuiKey_C)) { g.NavMoveDirLast = (ImGuiDir)((g.NavMoveDirLast + 1) & 3); g.IO.KeysDownDuration[g.IO.KeyMap[ImGuiKey_C]] = 0.01f; }
-      if (quadrant == g.NavMoveDir)
-      {
-         ImFormatString(buf, IM_ARRAYSIZE(buf), "%.0f/%.0f", dist_box, dist_center);
-         ImDrawList* draw_list = ImGui::GetOverlayDrawList();
-         draw_list->AddRectFilled(cand.Min, cand.Max, IM_COL32(255, 0, 0, 200));
-         draw_list->AddText(g.IO.FontDefault, 13.0f, cand.Min, IM_COL32(255, 255, 255, 255), buf);
-      }
-   }
-#endif
-
-   // Is it in the quadrant we're interesting in moving to?
-   bool new_best = false;
-   if (quadrant == g.NavMoveDir)
-   {
-      // Does it beat the current best candidate?
-      if (dist_box < result->DistBox)
-      {
-         result->DistBox = dist_box;
-         result->DistCenter = dist_center;
-         return true;
-      }
-      if (dist_box == result->DistBox)
-      {
-         // Try using distance between center points to break ties
-         if (dist_center < result->DistCenter)
-         {
-            result->DistCenter = dist_center;
-            new_best = true;
-         }
-         else if (dist_center == result->DistCenter)
-         {
-            // Still tied! we need to be extra-careful to make sure everything gets linked properly. We consistently break ties by symbolically moving "later" items 
-            // (with higher index) to the right/downwards by an infinitesimal amount since we the current "best" button already (so it must have a lower index), 
-            // this is fairly easy. This rule ensures that all buttons with dx==dy==0 will end up being linked in order of appearance along the x axis.
-            if (((g.NavMoveDir == ImGuiDir_Up || g.NavMoveDir == ImGuiDir_Down) ? dby : dbx) < 0.0f) // moving bj to the right/down decreases distance
-               new_best = true;
-         }
-      }
-   }
-
-   // Axial check: if 'curr' has no link at all in some direction and 'cand' lies roughly in that direction, add a tentative link. This will only be kept if no "real" matches
-   // are found, so it only augments the graph produced by the above method using extra links. (important, since it doesn't guarantee strong connectedness)
-   // This is just to avoid buttons having no links in a particular direction when there's a suitable neighbor. you get good graphs without this too.
-   // 2017/09/29: FIXME: This now currently only enabled inside menu bars, ideally we'd disable it everywhere. Menus in particular need to catch failure. For general navigation it feels awkward.
-   // Disabling it may however lead to disconnected graphs when nodes are very spaced out on different axis. Perhaps consider offering this as an option?
-   if (result->DistBox == FLT_MAX && dist_axial < result->DistAxial)  // Check axial match
-      if (g.NavLayer == 1 && !(g.NavWindow->Flags & ImGuiWindowFlags_ChildMenu))
-         if ((g.NavMoveDir == ImGuiDir_Left && dax < 0.0f) || (g.NavMoveDir == ImGuiDir_Right && dax > 0.0f) || (g.NavMoveDir == ImGuiDir_Up && day < 0.0f) || (g.NavMoveDir == ImGuiDir_Down && day > 0.0f))
-         {
-            result->DistAxial = dist_axial;
-            new_best = true;
-         }
-
-   return new_best;
-}
-
-static void NavSaveLastChildNavWindow(ImGuiWindow* child_window)
-{
-   ImGuiWindow* parent_window = child_window;
-   while (parent_window && (parent_window->Flags & ImGuiWindowFlags_ChildWindow) != 0 && (parent_window->Flags & (ImGuiWindowFlags_Popup | ImGuiWindowFlags_ChildMenu)) == 0)
-      parent_window = parent_window->ParentWindow;
-   if (parent_window && parent_window != child_window)
-      parent_window->NavLastChildNavWindow = child_window;
-}
-
-// Call when we are expected to land on Layer 0 after FocusWindow()
-static ImGuiWindow* NavRestoreLastChildNavWindow(ImGuiWindow* window)
-{
-   return window->NavLastChildNavWindow ? window->NavLastChildNavWindow : window;
-}
-
-static void NavRestoreLayer(int layer)
-{
-   ImGuiContext& g = *GImGui;
-   g.NavLayer = layer;
-   if (layer == 0)
-      g.NavWindow = NavRestoreLastChildNavWindow(g.NavWindow);
-   if (layer == 0 && g.NavWindow->NavLastIds[0] != 0)
-      SetNavIDWithRectRel(g.NavWindow->NavLastIds[0], layer, g.NavWindow->NavRectRel[0]);
-   else
-      ImGui::NavInitWindow(g.NavWindow, true);
-}
-
-static inline void NavUpdateAnyRequestFlag()
-{
-   ImGuiContext& g = *GImGui;
-   g.NavAnyRequest = g.NavMoveRequest || g.NavInitRequest || (IMGUI_DEBUG_NAV_SCORING && g.NavWindow != NULL);
-   if (g.NavAnyRequest)
-      IM_ASSERT(g.NavWindow != NULL);
-}
-
-static bool NavMoveRequestButNoResultYet()
-{
-   ImGuiContext& g = *GImGui;
-   return g.NavMoveRequest && g.NavMoveResultLocal.ID == 0 && g.NavMoveResultOther.ID == 0;
-}
-
-void ImGui::NavMoveRequestCancel()
-{
-   ImGuiContext& g = *GImGui;
-   g.NavMoveRequest = false;
-   NavUpdateAnyRequestFlag();
-}
-
-// We get there when either NavId == id, or when g.NavAnyRequest is set (which is updated by NavUpdateAnyRequestFlag above)
-static void ImGui::NavProcessItem(ImGuiWindow* window, const ImRect& nav_bb, const ImGuiID id)
-{
-   ImGuiContext& g = *GImGui;
-   //if (!g.IO.NavActive)  // [2017/10/06] Removed this possibly redundant test but I am not sure of all the side-effects yet. Some of the feature here will need to work regardless of using a _NoNavInputs flag.
-   //    return;
-
-   const ImGuiItemFlags item_flags = window->DC.ItemFlags;
-   const ImRect nav_bb_rel(nav_bb.Min - window->Pos, nav_bb.Max - window->Pos);
-   if (g.NavInitRequest && g.NavLayer == window->DC.NavLayerCurrent)
-   {
-      // Even if 'ImGuiItemFlags_NoNavDefaultFocus' is on (typically collapse/close button) we record the first ResultId so they can be used as a fallback
-      if (!(item_flags & ImGuiItemFlags_NoNavDefaultFocus) || g.NavInitResultId == 0)
-      {
-         g.NavInitResultId = id;
-         g.NavInitResultRectRel = nav_bb_rel;
-      }
-      if (!(item_flags & ImGuiItemFlags_NoNavDefaultFocus))
-      {
-         g.NavInitRequest = false; // Found a match, clear request
-         NavUpdateAnyRequestFlag();
-      }
-   }
-
-   // Scoring for navigation
-   if (g.NavId != id && !(item_flags & ImGuiItemFlags_NoNav))
-   {
-      ImGuiNavMoveResult* result = (window == g.NavWindow) ? &g.NavMoveResultLocal : &g.NavMoveResultOther;
-#if IMGUI_DEBUG_NAV_SCORING
-      // [DEBUG] Score all items in NavWindow at all times
-      if (!g.NavMoveRequest)
-         g.NavMoveDir = g.NavMoveDirLast;
-      bool new_best = NavScoreItem(result, nav_bb) && g.NavMoveRequest;
-#else
-      bool new_best = g.NavMoveRequest && NavScoreItem(result, nav_bb);
-#endif
-      if (new_best)
-      {
-         result->ID = id;
-         result->ParentID = window->IDStack.back();
-         result->Window = window;
-         result->RectRel = nav_bb_rel;
-      }
-   }
-
-   // Update window-relative bounding box of navigated item
-   if (g.NavId == id)
-   {
-      g.NavWindow = window;                                           // Always refresh g.NavWindow, because some operations such as FocusItem() don't have a window.
-      g.NavLayer = window->DC.NavLayerCurrent;
-      g.NavIdIsAlive = true;
-      g.NavIdTabCounter = window->FocusIdxTabCounter;
-      window->NavRectRel[window->DC.NavLayerCurrent] = nav_bb_rel;    // Store item bounding box (relative to window position)
-   }
-}
-
-// Declare item bounding box for clipping and interaction.
-// Note that the size can be different than the one provided to ItemSize(). Typically, widgets that spread over available surface
-// declare their minimum size requirement to ItemSize() and then use a larger region for drawing/interaction, which is passed to ItemAdd().
-bool ImGui::ItemAdd(const ImRect& bb, ImGuiID id, const ImRect* nav_bb_arg)
-{
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-
-   if (id != 0)
-   {
-      // Navigation processing runs prior to clipping early-out
-      //  (a) So that NavInitRequest can be honored, for newly opened windows to select a default widget
-      //  (b) So that we can scroll up/down past clipped items. This adds a small O(N) cost to regular navigation requests unfortunately, but it is still limited to one window. 
-      //      it may not scale very well for windows with ten of thousands of item, but at least NavMoveRequest is only set on user interaction, aka maximum once a frame.
-      //      We could early out with "if (is_clipped && !g.NavInitRequest) return false;" but when we wouldn't be able to reach unclipped widgets. This would work if user had explicit scrolling control (e.g. mapped on a stick)
-      window->DC.NavLayerActiveMaskNext |= window->DC.NavLayerCurrentMask;
-      if (g.NavId == id || g.NavAnyRequest)
-         if (g.NavWindow->RootWindowForNav == window->RootWindowForNav)
-            if (window == g.NavWindow || ((window->Flags | g.NavWindow->Flags) & ImGuiWindowFlags_NavFlattened))
-               NavProcessItem(window, nav_bb_arg ? *nav_bb_arg : bb, id);
-   }
-
-   window->DC.LastItemId = id;
-   window->DC.LastItemRect = bb;
-   window->DC.LastItemStatusFlags = 0;
-
-   // Clipping test
-   const bool is_clipped = IsClippedEx(bb, id, false);
-   if (is_clipped)
-      return false;
-   //if (g.IO.KeyAlt) window->DrawList->AddRect(bb.Min, bb.Max, IM_COL32(255,255,0,120)); // [DEBUG]
-
-   // We need to calculate this now to take account of the current clipping rectangle (as items like Selectable may change them)
-   if (IsMouseHoveringRect(bb.Min, bb.Max))
-      window->DC.LastItemStatusFlags |= ImGuiItemStatusFlags_HoveredRect;
-   return true;
+    // An active popup disable hovering on other windows (apart from its own children)
+    // FIXME-OPT: This could be cached/stored within the window.
+    ImGuiContext& g = *GImGui;
+    if (g.NavWindow)
+        if (ImGuiWindow* focused_root_window = g.NavWindow->RootWindow)
+            if (focused_root_window->WasActive && focused_root_window != window->RootWindow)
+            {
+                // For the purpose of those flags we differentiate "standard popup" from "modal popup"
+                // NB: The order of those two tests is important because Modal windows are also Popups.
+                if (focused_root_window->Flags & ImGuiWindowFlags_Modal)
+                    return false;
+                if ((focused_root_window->Flags & ImGuiWindowFlags_Popup) && !(flags & ImGuiHoveredFlags_AllowWhenBlockedByPopup))
+                    return false;
+            }
+    return true;
 }
 
@@ -2470,39 +3065,41 @@
 bool ImGui::IsItemHovered(ImGuiHoveredFlags flags)
 {
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   if (g.NavDisableMouseHover && !g.NavDisableHighlight)
-      return IsItemFocused();
-
-   // Test for bounding box overlap, as updated as ItemAdd()
-   if (!(window->DC.LastItemStatusFlags & ImGuiItemStatusFlags_HoveredRect))
-      return false;
-   IM_ASSERT((flags & (ImGuiHoveredFlags_RootWindow | ImGuiHoveredFlags_ChildWindows)) == 0);   // Flags not supported by this function
-
-                                                                                                // Test if we are hovering the right window (our window could be behind another window)
-                                                                                                // [2017/10/16] Reverted commit 344d48be3 and testing RootWindow instead. I believe it is correct to NOT test for RootWindow but this leaves us unable to use IsItemHovered() after EndChild() itself.
-                                                                                                // Until a solution is found I believe reverting to the test from 2017/09/27 is safe since this was the test that has been running for a long while.
-                                                                                                //if (g.HoveredWindow != window)
-                                                                                                //    return false;
-   if (g.HoveredRootWindow != window->RootWindow && !(flags & ImGuiHoveredFlags_AllowWhenOverlapped))
-      return false;
-
-   // Test if another item is active (e.g. being dragged)
-   if (!(flags & ImGuiHoveredFlags_AllowWhenBlockedByActiveItem))
-      if (g.ActiveId != 0 && g.ActiveId != window->DC.LastItemId && !g.ActiveIdAllowOverlap && g.ActiveId != window->MoveId)
-         return false;
-
-   // Test if interactions on this window are blocked by an active popup or modal 
-   if (!IsWindowContentHoverable(window, flags))
-      return false;
-
-   // Test if the item is disabled
-   if (window->DC.ItemFlags & ImGuiItemFlags_Disabled)
-      return false;
-
-   // Special handling for the 1st item after Begin() which represent the title bar. When the window is collapsed (SkipItems==true) that last item will never be overwritten so we need to detect tht case.
-   if (window->DC.LastItemId == window->MoveId && window->WriteAccessed)
-      return false;
-   return true;
+    ImGuiContext& g = *GImGui;
+    ImGuiWindow* window = g.CurrentWindow;
+    if (g.NavDisableMouseHover && !g.NavDisableHighlight)
+        return IsItemFocused();
+
+    // Test for bounding box overlap, as updated as ItemAdd()
+    if (!(window->DC.LastItemStatusFlags & ImGuiItemStatusFlags_HoveredRect))
+        return false;
+    IM_ASSERT((flags & (ImGuiHoveredFlags_RootWindow | ImGuiHoveredFlags_ChildWindows)) == 0);   // Flags not supported by this function
+
+    // Test if we are hovering the right window (our window could be behind another window)
+    // [2017/10/16] Reverted commit 344d48be3 and testing RootWindow instead. I believe it is correct to NOT test for RootWindow but this leaves us unable to use IsItemHovered() after EndChild() itself.
+    // Until a solution is found I believe reverting to the test from 2017/09/27 is safe since this was the test that has been running for a long while.
+    //if (g.HoveredWindow != window)
+    //    return false;
+    if (g.HoveredRootWindow != window->RootWindow && !(flags & ImGuiHoveredFlags_AllowWhenOverlapped))
+        return false;
+
+    // Test if another item is active (e.g. being dragged)
+    if (!(flags & ImGuiHoveredFlags_AllowWhenBlockedByActiveItem))
+        if (g.ActiveId != 0 && g.ActiveId != window->DC.LastItemId && !g.ActiveIdAllowOverlap && g.ActiveId != window->MoveId)
+            return false;
+
+    // Test if interactions on this window are blocked by an active popup or modal.
+    // The ImGuiHoveredFlags_AllowWhenBlockedByPopup flag will be tested here.
+    if (!IsWindowContentHoverable(window, flags))
+        return false;
+
+    // Test if the item is disabled
+    if ((window->DC.ItemFlags & ImGuiItemFlags_Disabled) && !(flags & ImGuiHoveredFlags_AllowWhenDisabled))
+        return false;
+
+    // Special handling for calling after Begin() which represent the title bar or tab.
+    // When the window is collapsed (SkipItems==true) that last item will never be overwritten so we need to detect the case.
+    if (window->DC.LastItemId == window->MoveId && window->WriteAccessed)
+        return false;
+    return true;
 }
 
